water = {
    cool = 0,
    hot = 0,
    bat = 3,
    -- unit = "water01"
}
sent = {
    cool = 0,
    hot = 0,
}
hotp = 6
coolp = 7

-- timeNextCheck = 3600000 -- Один час
timeNextCheck = 20000
-- Broker="broker.hivemq.com"
Broker="iot.eclipse.org"
port=1883
myClient="water01777211"
pass="pass"
m = mqtt.Client(myClient, 180, myClient, pass)
m:lwt("/lwt", myClient, 0, 0)

function connecting(call)
    print('Connecting')
    wifi.setmode(wifi.STATION)
    wifi.sta.config("AP", "password", 0)
    wifi.sta.connect()
    
    function getWiFi()
        local count = 0
		tmr.alarm(5, 500, 1, function()
            if wifi.sta.status() == 5 and wifi.sta.getip() ~= nil then
                getConnect(call)
                tmr.unregister(5)
            end
			count = count + 1
			if count > 30 then
				tmr.unregister(5)
				closeWiFi()
			end
			
        end)
    end

    function getConnect(call)
        print("Got WiFi!")
        m:connect(Broker, port, 0, 0,
            function(conn)
                tmr.stop(6)
                print("Connected")
                if call then
                    call()
                else                
                    m:publish(myClient.."/report","Waiting Data",0,0, function() 
                        m:subscribe({[myClient.."/cool"]=1,[myClient.."/hot"]=1}, function(conn)    
                        print("Subscribed")
                    end)
                    
                    end)
                end
			end,
			function(conn, reason)
				print(reason)
				closeWiFi()
			end
		)
    end
    getWiFi()
 

end
function publ(datt)
    local send = coroutine.create(function(close) 
        water.bat = adc.readvdd33()/1000
        for k,v in pairs(water) do
            pub(k,v)
            coroutine.yield()
        end 
		sent.cool = water.cool
		sent.hot = water.hot
        return close()
    end)

    function pub(topic, info)
            print(topic..": "..info)
            m:publish(myClient.."/"..topic,info,1,1, function() 
                coroutine.resume(send)
            end)
    end
    
    if(datt) then
        m:publish(myClient.."/report", datt,0,0,function(conn)
            print("Cool: "..water.cool)
            print("Hot: "..water.hot)
            print(datt)
            closeWiFi()
            return
        end)
    else
        coroutine.resume(send, closeWiFi)
    end
 end


m:on("message", function(conn, topic, data)
    if (string.find(topic, "state")) == nil then 
        local top = string.gsub(topic, myClient.."/","")
        if top == "cool" then 
            water.cool =  tonumber(data)  
        end
        if top == "hot" then  
            water.hot = tonumber(data)
        end
    end
    if water.cool ~= 0 and water.hot ~=0 then 
        m:unsubscribe(myClient.."/#", function(conn) print("Unsubscribed.") end)
		local rep = "Got "..water.cool.." & "..water.hot..". Ready!"
        publ(rep)
    end
end)

function closeWiFi()
    m:close()
	wifi.setmode(wifi.NULLMODE)
    -- sent.cool = water.cool
    -- sent.hot = water.hot
    print("WiFi switched OFF")
end

function debounce (func, pinn)
    local last = 0
    local delay = 50000 

    return function (...)
        local now = tmr.now()
        local delta = now - last
        if delta < 0 then delta = delta + 2147483647 end; 
        if delta < delay then return end;
        last = now
        return func(pinn)
    end

end

function onChange (which)
    if(which == "cool") then
        water.cool = water.cool + 10
        print("Cool got "..water.cool.." liters.")
    else 
        water.hot = water.hot + 10
        print("Hot got "..water.hot.." liters.")
    end
end
function setPins()
    gpio.mode(hotp, gpio.INT)
    gpio.trig(hotp, 'down', debounce(onChange, "hot"))
    gpio.mode(coolp, gpio.INT)
    gpio.trig(coolp, 'down', debounce(onChange, "cool"))
    wifi.setmode(wifi.NULLMODE)
end
setPins()
connecting()

tmr.alarm(1, timeNextCheck, tmr.ALARM_AUTO, 
    function() 
        if(((water.cool ~= sent.cool) or (water.hot ~= sent.hot)) and publ )then
            connecting(publ)
        end 
end) 
